/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the ExternalSystem type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ExternalSystem{}

// ExternalSystem struct for ExternalSystem
type ExternalSystem struct {
	Name *string `json:"name,omitempty"`
	UserLink *string `json:"user_link,omitempty"`
	UserIdPattern *string `json:"user_id_pattern,omitempty"`
}

// NewExternalSystem instantiates a new ExternalSystem object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewExternalSystem() *ExternalSystem {
	this := ExternalSystem{}
	return &this
}

// NewExternalSystemWithDefaults instantiates a new ExternalSystem object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewExternalSystemWithDefaults() *ExternalSystem {
	this := ExternalSystem{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *ExternalSystem) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExternalSystem) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *ExternalSystem) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *ExternalSystem) SetName(v string) {
	o.Name = &v
}

// GetUserLink returns the UserLink field value if set, zero value otherwise.
func (o *ExternalSystem) GetUserLink() string {
	if o == nil || IsNil(o.UserLink) {
		var ret string
		return ret
	}
	return *o.UserLink
}

// GetUserLinkOk returns a tuple with the UserLink field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExternalSystem) GetUserLinkOk() (*string, bool) {
	if o == nil || IsNil(o.UserLink) {
		return nil, false
	}
	return o.UserLink, true
}

// HasUserLink returns a boolean if a field has been set.
func (o *ExternalSystem) HasUserLink() bool {
	if o != nil && !IsNil(o.UserLink) {
		return true
	}

	return false
}

// SetUserLink gets a reference to the given string and assigns it to the UserLink field.
func (o *ExternalSystem) SetUserLink(v string) {
	o.UserLink = &v
}

// GetUserIdPattern returns the UserIdPattern field value if set, zero value otherwise.
func (o *ExternalSystem) GetUserIdPattern() string {
	if o == nil || IsNil(o.UserIdPattern) {
		var ret string
		return ret
	}
	return *o.UserIdPattern
}

// GetUserIdPatternOk returns a tuple with the UserIdPattern field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExternalSystem) GetUserIdPatternOk() (*string, bool) {
	if o == nil || IsNil(o.UserIdPattern) {
		return nil, false
	}
	return o.UserIdPattern, true
}

// HasUserIdPattern returns a boolean if a field has been set.
func (o *ExternalSystem) HasUserIdPattern() bool {
	if o != nil && !IsNil(o.UserIdPattern) {
		return true
	}

	return false
}

// SetUserIdPattern gets a reference to the given string and assigns it to the UserIdPattern field.
func (o *ExternalSystem) SetUserIdPattern(v string) {
	o.UserIdPattern = &v
}

func (o ExternalSystem) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ExternalSystem) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.UserLink) {
		toSerialize["user_link"] = o.UserLink
	}
	if !IsNil(o.UserIdPattern) {
		toSerialize["user_id_pattern"] = o.UserIdPattern
	}
	return toSerialize, nil
}

type NullableExternalSystem struct {
	value *ExternalSystem
	isSet bool
}

func (v NullableExternalSystem) Get() *ExternalSystem {
	return v.value
}

func (v *NullableExternalSystem) Set(val *ExternalSystem) {
	v.value = val
	v.isSet = true
}

func (v NullableExternalSystem) IsSet() bool {
	return v.isSet
}

func (v *NullableExternalSystem) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExternalSystem(val *ExternalSystem) *NullableExternalSystem {
	return &NullableExternalSystem{value: val, isSet: true}
}

func (v NullableExternalSystem) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExternalSystem) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


